#include <cv.h>
#include <highgui.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>

void DrawFres(CvArr* img, int x0, int y0, float *Xg, float *Xt);
void CalcFres(float* Xg, float* Xt);
void TxtSave(char *fn);
void SZTrans();
void FreqTrans();
void PreWarp();
void BasicFilCal();

float Pi = 3.1415926;
	float Gain[400];
	float Theta[400];
	float Fsamp;
	float gain_range;
	float freq_range;
	int FilType;
	int OrderN;
	float p_AC;
	float p_fc;
	float p_fc2;
	float Pi;
	float PN2, PN1, PN0, PD2, PD1, PD0;
	float SN2, SN1, SN0, SD2, SD1, SD0, SH;
	float TN2, TN1, TN0, TD2, TD1, TD0, TH;
	float FC1;
	float FC2;
	float fcp1;
	float fcp2;
	float p_Fsamp;
	float p_a0[8];
	float p_a1[8];
	float p_a2[8];
	float p_b1[8];
	float p_b2[8];

int evenTap;

int main(int argc, char *argv[]) {

  IplImage *img;
  int val, valp1;
  int i;

	for (i = 0; i < 8; i++) { 
		p_a0[i] = 1.0; 
		p_a1[i] = 0.0; 
		p_a2[i] = 0.0; 
		p_b1[i] = 0.0; 
		p_b2[i] = 0.0; 
	}
	Pi = 3.14159;
	gain_range = 100.0;
	Fsamp = 22050;
	freq_range = 10000;//Fsamp/2.0;
	OrderN = 2;
	FilType = 0;
	FC1 = 2000;
	FC2 = 5000;

  img = cvCreateImage (cvSize (640, 360), 8, 3);

  cvSet (img, cvScalarAll (255), 0);

	p_Fsamp = Fsamp;

	p_fc = FC1; 
	p_fc2 = FC2;
	p_AC = 3.0;

	BasicFilCal();
	PreWarp();
	FreqTrans();
	SZTrans();

		CalcFres(Gain, Theta);
		DrawFres(img, 100, 60, Gain, Theta);

    while(1) {
        cvNamedWindow ("Frequency Response", CV_WINDOW_AUTOSIZE);
        cvShowImage ("Frequency Response", img);
        if(cvWaitKey(1)>=0) break;
    }

        TxtSave("coeff1.txt");

  return 0;
}

void CalcFres(float* Xg, float* Xt) {
	int i;
	float	omega;
	float	AReal;
	float	AImag;
	float	AAbs_2;
	float	BReal;
	float	BImag;
	float	BAbs_2;
	float	HAbs_2;
	float	HzdB;
	float	HThita;

	int k;

	int int_th;

	for(i = 0; i < 360; i++) {
		Xg[i] = 0.0;
		Xt[i] = 0.0;
		for(k = 0; k < 2; k++) {
			omega = i * Pi / 180.0 + 0.001;

			AReal = 0.0; AImag = 0.0;

			AReal =  p_a0[k] + p_a1[k] * cos(1.0 * omega) + p_a2[k] * cos(2.0 * omega);
			AImag = 0.0 - p_a1[k] * sin(1.0 * omega) - p_a2[k] * sin(2.0 * omega);
			AAbs_2 = AReal * AReal + AImag * AImag;

			BReal = 0.0; BImag = 0.0;

			BReal = 1.0 + p_b1[k] * cos(1.0 * omega) + p_b2[k] * cos(2.0 * omega);
			BImag = 0.0 - p_b1[k] * sin(1.0 * omega) - p_b2[k] * sin(2.0 * omega);
			BAbs_2 = BReal * BReal + BImag * BImag;

			HAbs_2 = AAbs_2 / BAbs_2;
			HzdB = 10 * log10(HAbs_2);

			HzdB = HzdB;

			HThita = 
				atan((AImag*BReal - AReal*BImag) / (AReal*BReal + AImag*BImag));
		
			Xg[i] = Xg[i] + HzdB;
			Xt[i] = Xt[i] + HThita;
			if( Xt[i] < -3.15 ) { 
				int_th = (int)(Xt[i] * 100);
				int_th = int_th % 314;
				Xt[i] = ((double)(int_th)) / 314; 
			}
			if( Xt[i] > 3.15 ) { 
				int_th = (int)(Xt[i] * 100);
				int_th = int_th % 314;
				Xt[i] = ((double)(int_th)) / 314; 
			} 
		}
	}
}

void DrawFres(CvArr* img, int x0, int y0, float *Xg, float *Xt)
{

	float start_fr, end_fr, mid_fr;
	float tmp_xg[400], tmp_xt[400];
	int	i;
	char freq_char[15];
	char gain_char[15];
	float xstep = 2.0;

  CvFont font;
  int font_face[] = {
    CV_FONT_HERSHEY_SIMPLEX,
    CV_FONT_HERSHEY_PLAIN,
    CV_FONT_HERSHEY_DUPLEX,
    CV_FONT_HERSHEY_COMPLEX,
    CV_FONT_HERSHEY_TRIPLEX,
    CV_FONT_HERSHEY_COMPLEX_SMALL,
    CV_FONT_HERSHEY_SCRIPT_SIMPLEX,
    CV_FONT_HERSHEY_SCRIPT_COMPLEX
  };

  cvInitFont(&font, font_face[0], 0.5, 0.5, 0, 1, 8);

	for (i = 0; i < 400; i++) tmp_xg[i] = 0.0;

	cvPutText(img, "Gain [dB]", cvPoint(x0 - 50, y0 - 28) , &font, CV_RGB(0, 0, 0));
	sprintf(gain_char,"%5.1f", gain_range/5.0);
	cvPutText(img, gain_char, cvPoint(x0 - 50, y0 - 0), &font, CV_RGB(0, 0, 0));

	cvPutText(img, "  0", cvPoint(x0 - 30, y0 + 40), &font, CV_RGB(0, 0, 0));

	sprintf(gain_char,"-%5.1f", gain_range/2.0);
	cvPutText(img, gain_char, cvPoint( x0 - 60, y0 + 145 ), &font, CV_RGB(0, 0, 0));
	sprintf(gain_char,"-%5.1f", gain_range);
	cvPutText(img, gain_char, cvPoint( x0 - 60, y0 + 240 ), &font, CV_RGB(0, 0, 0));
	
	cvPutText(img, "Phase [rad]", cvPoint( x0 + 360 - 10, y0 - 20), &font, CV_RGB(0,0,0));
	cvPutText(img, "  pi ", cvPoint( x0 + 360 + 10, y0 + 60 ), &font, CV_RGB(0,0,0));
	cvPutText(img, " pi/2", cvPoint( x0 + 360 + 10, y0 + 100 ), &font, CV_RGB(0,0,0));
	cvPutText(img, "   0 ", cvPoint( x0 + 360 + 10, y0 + 140 ), &font, CV_RGB(0,0,0));
	cvPutText(img, "-pi/2", cvPoint( x0 + 360 + 10, y0 + 180 ), &font, CV_RGB(0,0,0));
	cvPutText(img, " -pi ", cvPoint( x0 + 360 + 10, y0 + 220 ), &font, CV_RGB(0,0,0));

	start_fr = 0.0;
	end_fr = start_fr + freq_range / 1.0;
	mid_fr = start_fr + freq_range / 2.0;

	sprintf(freq_char,"%10.0f", start_fr);
	cvPutText(img, freq_char, cvPoint( x0 - 70, y0 + 255 ), &font, CV_RGB(0,0,0));
	sprintf(freq_char,"%10.0f", mid_fr);
	cvPutText(img, freq_char, cvPoint( x0 - 35 + 150, y0 + 255 ), &font, CV_RGB(0,0,0));
	sprintf(freq_char,"%10.0f", end_fr);
	cvPutText(img, freq_char, cvPoint( x0 - 35 + 330, y0 + 255 ), &font, CV_RGB(0,0,0));
	cvPutText(img, "[Hz]", cvPoint( x0 - 10 + 410, y0 + 255 ), &font, CV_RGB(0,0,0));

//	sprintf(freq_char,"hh = %10.3f", hh[0]);
//	cvPutText(img, freq_char, cvPoint( x0 - 50, y0 + 255 ), &font, CV_RGB(0,0,0));

	for(i = 0; i <= 12; i++) {
		cvLine( img, cvPoint(x0      , y0 + i * 20),
				cvPoint(x0 + 360, y0 + i * 20),
				CV_RGB(200, 200, 200), 1, 8, 0);
	}

	for(i = 0; i <= 10; i++) {
		cvLine( img, cvPoint(x0 + i * (360 / 10), y0),
				cvPoint(x0 + i * (360 / 10), y0+240),
				CV_RGB(200, 200, 200), 1, 8, 0);
	}

//	cvLine( img, cvPoint(x0      , y0 + 2 * 20),
//			cvPoint(x0 + 360, y0 + 2 * 20),
//			CV_RGB(100, 100, 100), 1, 8, 0);
//
//	cvLine( img, cvPoint(x0 + 5 * (360 / 10), y0),
//			cvPoint(x0 + 5 * (360 / 10), y0 + 240),
//			CV_RGB(100, 100, 100), 1, 8, 0);

	// Frame drawing
	for(i = 0; i <= 12; i = i + 12) {
		cvLine( img, cvPoint(x0      , y0 + i * 20),
				cvPoint(x0 + 360, y0 + i * 20),
				CV_RGB(100, 100, 100), 1, 8, 0);
	}
	for(i = 0; i <= 10; i = i + 10) {
		cvLine( img, cvPoint(x0 + i * (360 / 10), y0),
				cvPoint(x0 + i * (360 / 10), y0 + 240),
				CV_RGB(100, 100, 100), 1, 8, 0);
	}

	
	for(i = 0; i < 180; i++) {
    		tmp_xt[i] = 25.5 * Xt[i];
	}

	xstep = Fsamp/freq_range;

	for(i = 0; i < 179; i++) {
		if( (i+1)*xstep < 360 ) {
			cvLine( img, cvPoint(x0 + (int)(i*xstep), y0 + 140 - (int)(tmp_xt[i])),
					cvPoint(x0 + (int)((i+1)*xstep), y0 + 140 - (int)(tmp_xt[i + 1])),
					CV_RGB(0, 200, 0), 1, 8, 0);
		}
	}
	
	cvPutText(img, "Phase", cvPoint( x0 + 200, y0 - 25 ), &font, CV_RGB(0,0,0));
	cvLine( img, cvPoint(x0 + 250, y0 - 30),
			cvPoint(x0 + 270, y0 - 30),
			CV_RGB(0, 255, 0), 1, 8, 0);

	float ymax, ymin, yrange;

	ymax = 40.0;
	ymin = -200.0;
	yrange = 2.0 * 100.0 / gain_range;

	for(i = 0; i < 180; i++) {
    	tmp_xg[i] = yrange * Xg[i];
		if( tmp_xg[i] < ymin ) tmp_xg[i] = ymin;
		if( tmp_xg[i] > ymax ) tmp_xg[i] = ymax;
	}

	for(i = 0; i < 179; i++) {
		//tmp_xg[i] = 10;
		if( (i+1)*xstep < 360 ) {
			cvLine( img, cvPoint(x0 + (int)(i*xstep), y0 + 40 - (int)(tmp_xg[i])),
					cvPoint(x0 + (int)((i+1)*xstep), y0 + 40 - (int)(tmp_xg[i + 1])),
					CV_RGB(255, 0, 0), 1, 8, 0);

		}
	}
	cvPutText(img, "Gain", cvPoint( x0 + 100, y0 - 25), &font, CV_RGB(0,0,0));
	cvLine( img, cvPoint(x0 + 140, y0 - 30),
			cvPoint(x0 + 160, y0 - 30),
			CV_RGB(255, 0, 0), 1, 8, 0);

}

//////////////////////////////////////////////
// Basic Analog LPF
void BasicFilCal() // Butterworth
{
	int i;
	float d0, bi, ai;
	float eps;

	eps = sqrt(pow(10.0, p_AC/10.0) - 1);
	d0 = pow(eps, (-1.0/OrderN));
	bi = d0 * d0;
	i = 1;
	ai = 2.0 * d0 * sin( i * Pi / (2.0 * OrderN) );

	if( OrderN == 1 ) {
		PN2 = 0.0; PN1 = 0.0; PN0 = d0;
		PD2 = 0.0; PD1 = 1.0; PD0 = d0;
	} else {
		PN2 = 0.0; PN1 = 0.0; PN0 = bi; 
		PD2 = 1.0; PD1 = ai; PD0 = bi;
	}
}	

//////////////////////////////////////////////
// Pre Warping
void PreWarp()
{
	float tmp_wc1, tmp_wc2;

	FC1 = (float)p_fc;
	tmp_wc1 = (2.0 * p_Fsamp) * tan(2.0 * Pi * FC1 / (2.0 * p_Fsamp));
	fcp1 = (float)(tmp_wc1 / (2.0 * Pi));

	FC2 = (float)p_fc2;
	tmp_wc2 = (2.0 * p_Fsamp) * tan(2.0 * Pi * FC2 / (2.0 * p_Fsamp));
	fcp2 = (float)(tmp_wc2 / (2.0 * Pi));

}

//////////////////////////////////////////////
// Frequency Transformation
void FreqTrans()
{
	float wc1, wc2;
	float wb, w0;
	float xx, dd, ww, zz, uu, vv;

	wc1 = 2.0 * Pi * fcp1;
	wc2 = 2.0 * Pi * fcp2;
	wb = wc2 - wc1;
	w0 = sqrt(wc1 * wc2);

	if( FilType == 0 ) { // LPF
		if( OrderN == 1 ) {
			SH  = PD0 * wc1;
			SN2 = 0.0; SN1 = 0.0; SN0 = 1.0;
			SD2 = 0.0; SD1 = 1.0; SD0 = PD0 * wc1;
		} else {
			SH  = PD0 * wc1 * wc1;
			SN2 = 0.0; SN1 = 0.0; SN0 = 1.0;
			SD2 = 1.0; SD1 = PD1 * wc1; SD0 = PD0 * wc1 * wc1;
		}
	} else if( FilType == 1 ) { // HPF
		if( OrderN == 1 ) {
			SH  = 1.0;
			SN2 = 0.0; SN1 = 1.0; SN0 = 0.0;
			SD2 = 0.0; SD1 = 1.0; SD0 = wc1 / PD0;
		} else {
			SH  = 1.0;
			SN2 = 1.0; SN1 = 0.0; SN0 = 0.0;
			SD2 = 1.0; SD1 = PD1 * wc1 / PD0; SD0 = wc1 * wc1 / PD0;
		}
	} else if( FilType == 2 ) { // BPF
		xx = wb / w0;
		dd = PD1 * xx / 2.0;
		ww = xx * sqrt(4.0 * PD0 - PD1 * PD1 ) / 2.0;
		zz = 4.0 - dd * dd + ww * ww;
		uu = sqrt(zz / 2 + sqrt(zz * zz / 4.0 + dd * dd * ww * ww));
		vv = dd * ww / uu;
		if( OrderN == 1 ) {
			SH  = PD0 * wb;
			SN2 = 0.0; SN1 = 1.0; SN0 = 0.0;
			SD2 = 1.0; SD1 = PD0 * wb; SD0 = w0 * w0;
		} else { 
			SH   = sqrt(wb * wb * PD0);
			SN2 = 0.0; SN1 = 1.0; SN0 = 0.0;
			SD2 = 1.0; SD1 = w0 * (dd + vv);
			SD0 = w0 * w0 * ((dd + vv) * (dd + vv) 
				+ (ww + uu) * (ww + uu)) / 4.0;

			TH  = sqrt(wb * wb * PD0);
			TN2 = 0.0; TN1 = 1.0; TN0 = 0.0;
			TD2 = 1.0; TD1 = w0 * (dd - vv);
			TD0 = w0 * w0 * ((dd - vv) * (dd - vv) 
				+ (ww - uu) * (ww - uu)) / 4.0;
		}
	} else if( FilType == 3 ) { // BRF
		xx = wb / w0;
		dd = (PD1/PD0) * xx / 2.0;
		ww = xx * sqrt(4.0 * (1.0/PD0) - (PD1/PD0) * (PD1/PD0) ) / 2.0;
		zz = 4.0 - dd * dd + ww * ww;
		uu = sqrt(zz / 2 + sqrt(zz * zz / 4.0 + dd * dd * ww * ww));
		vv = dd * ww / uu;
		if( OrderN == 1 ) {
			SH  = 1.0;
			SN2 = 1.0; SN1 = 0.0; SN0 = w0 * w0;
			SD2 = 1.0; SD1 = wb / PD0; SD0 = w0 * w0;
		} else {
			SH  = 1.0;
			SN2 = 1.0; SN1 = 0.0; SN0 = w0 * w0;
			SD2 = 1.0; SD1 = w0 * (dd + vv);
			SD0 = w0 * w0 * ((dd + vv) * (dd + vv) 
				+ (ww + uu) * (ww + uu)) / 4.0;
			TH  = 1.0;
			TN2 = 1.0; TN1 = 0.0; TN0 = w0 * w0;
			TD2 = 1.0; TD1 = w0 * (dd - vv);
			TD0 = w0 * w0 * ((dd - vv) * (dd - vv) 
				+ (ww - uu) * (ww - uu)) / 4.0;
		}
	}
}

//////////////////////////////////////////////
// s-z Transformation
void SZTrans()
{
	float alpha, beta, gg;
	int i;
	for (i = 0; i < 8; i++) {
		p_a0[i]=1.0; p_a1[i]=0.0; p_a2[i]=0.0; p_b1[i]=0.0; p_b2[i]=0.0;
	}

	alpha = 2.0 * p_Fsamp;

	if( FilType == 0 || FilType == 1 ) {
		if( OrderN == 1 ) {
			gg = 1.0 / (SD0 + alpha);
			p_a0[0] = (SN1 * alpha + SN0) * SH * gg;
			p_a1[0] = (SN0 - SN1 * alpha) * SH * gg;
			p_a2[0] = 0.0 * SH;
			p_b1[0] = (SD0 - alpha) / (SD0 + alpha);
			p_b2[0] = 0.0;
		} else {
			beta = SN2 * alpha * alpha;
			gg  = 1.0 / (alpha * alpha + SD1 * alpha + SD0);
			p_a0[0] = (beta + SN1 * alpha + SN0) * SH * gg;
			p_a1[0] = 2.0 * (SN0 - beta) * SH * gg;
			p_a2[0] = (beta - SN1 * alpha + SN0) * SH * gg;
			p_b1[0] = 2.0 * gg * (SD0 - alpha * alpha);
			p_b2[0] = gg * (alpha * alpha - SD1 * alpha + SD0);
		}
	} else {
		beta = SN2 * alpha * alpha;
		gg  = 1.0 / (alpha * alpha + SD1 * alpha + SD0);
		p_a0[0] = (beta + SN1 * alpha + SN0) * SH * gg;
		p_a1[0] = 2.0 * (SN0 - beta) * SH * gg;
		p_a2[0] = (beta - SN1 * alpha + SN0) * SH * gg;
		p_b1[0] = 2.0 * gg * (SD0 - alpha * alpha);
		p_b2[0] = gg * (alpha * alpha - SD1 * alpha + SD0);
		if( OrderN == 2 ) {
			beta = TN2 * alpha * alpha;
			gg  = 1.0 / (alpha * alpha + TD1 * alpha + TD0);
			p_a0[1] = (beta + TN1 * alpha + TN0) * TH * gg;
			p_a1[1] = 2.0 * (TN0 - beta) * TH * gg;
			p_a2[1] = (beta - TN1 * alpha + TN0) * TH * gg;
			p_b1[1] = 2.0 * gg * (TD0 - alpha * alpha);
			p_b2[1] = gg * (alpha * alpha - TD1 * alpha + TD0);
		}
	}
}

void TxtSave(char *fn)
{
  int i;
  char charline[40];
  FILE *fp;
  int filco;

  fp = fopen( fn, "w" );
  if( fp == NULL ){
    printf( "%s cannot be opened.\n", fn );
    exit(1);
  }

  fseek( fp, 0L, SEEK_SET );

	if( (FilType == 2 || FilType == 3) && (OrderN == 2) ) {
		filco = 2;
	} else {
		filco = 1;
	}
	for( i = 0; i < filco; i++ ) {
		sprintf(charline, "%f\n", p_a0[i]);
		fputs(charline, fp);
		sprintf(charline, "%f\n", p_a1[i]);
		fputs(charline, fp);
		sprintf(charline, "%f\n", p_a2[i]);
		fputs(charline, fp);
		sprintf(charline, "%f\n", p_b1[i]);
		fputs(charline, fp);
		sprintf(charline, "%f\n", p_b2[i]);
		fputs(charline, fp);
	}

  fclose( fp );
}

